> ## Documentation Index
> Fetch the complete documentation index at: https://docs.chainstack.com/llms.txt
> Use this file to discover all available pages before exploring further.

# trace_block | Polygon

> Polygon API method that returns traces for all the transactions within a specific block. Available on Polygon via Chainstack JSON-RPC nodes.

Polygon API method that returns traces for all the transactions within a specific block. Developers can use the `trace_block` method to gain insight into the behavior of smart contracts within a block, analyze gas usage and optimize their contracts accordingly. This method is only available on an Erigon instance.

## Parameters

* `quantity or tag` — the integer of a block encoded as hexadecimal or the string with:

  * `latest` — the most recent block in the blockchain and the current state of the blockchain at the most recent block
  * `earliest` — the earliest available or genesis block
  * `pending` — the pending state and transactions block. The current state of transactions that have been broadcast to the network but have not yet been included in a block.

<Note>
  See the [default block parameter](https://ethereum.org/en/developers/docs/apis/json-rpc/#default-block).
</Note>

## Response

* `result` — an object containing the traces of all of the transactions in the block:
  * `action` — an object that describes the action taken by the transaction:
    * `from` — the address of the sender who initiated the transaction.
    * `callType` — the type of call, `call` or `delegatecall`, two ways to invoke a function in a smart contract. `call` creates a new environment for the function to work in, so changes made in that function won't affect the environment where the function was called. `delegatecall` doesn't create a new environment. Instead, it runs the function within the environment of the caller, so changes made in that function will affect the caller's environment.
    * `gas` — the units of gas included in the transaction by the sender.
    * `input` — the optional input data sent with the transaction, usually used to interact with smart contracts.
    * `to` — the address of the recipient of the transaction if it was a transaction to an address. For contract creation transactions, this field is null.
    * `value` — the value of the native token transferred along with the transaction, in Wei.
    * `blockHash` — the hash of the block in which the transaction was included.
    * `blockNumber` — the number of the block in which the transaction was included.
    * `error` — a string that indicates whether the transaction was successful or not. `null` if successful, `Reverted` if not.
    * `result` — an object that contains additional data about the execution of the transaction:
      * `gasUsed` — the total used gas by the call, encoded as hexadecimal.
      * `output` — the return value of the call, encoded as a hexadecimal string.
    * `subtraces` — the number of sub-traces created during execution. When a transaction is executed on the EVM, it may trigger additional sub-executions, such as when a smart contract calls another smart contract or when an external account is accessed.
    * `traceAddress` — an array that indicates the position of the transaction in the trace.
    * `transactionHash` — the hash of the transaction.
    * `transactionPosition` — the position of the transaction in the block.
    * `type` — the type of action taken by the transaction, `call` or `create`. `call`  is the most common type of trace and occurs when a smart contract invokes another contract's function. `create` represents the creation of a new smart contract. This type of trace occurs when a smart contract is deployed to the blockchain.

## `trace_block` code examples

<CodeGroup>
  ```javascript ethers.js theme={"system"}
  const ethers = require('ethers');
  const NODE_URL = "CHAINSTACK_NODE_URL";
  const provider = new ethers.JsonRpcProvider(NODE_URL);

  const traceBlock = async (block) => {
    const traces = await provider.send("trace_block", [block]);
    console.log(traces);
  };

  traceBlock("latest")
  ```

  ```python web3.py theme={"system"}
  from web3 import Web3  
  node_url = "CHAINSTACK_NODE_URL" 
  web3 = Web3.HTTPProvider(node_url)

  block = "latest"

  traces = web3.provider.make_request('trace_block', [block])
  print(traces)
  ```
</CodeGroup>

## Use case

A practical use case for the `trace_block` method on Polygon can be to conduct an analysis of the most recent block on the network. For example, by examining the amount of gas supplied by all the transactions and the actual amount of gas utilized, developers can gain valuable insights into the block's behavior. This can be the first step to developing a chain explorer.

The following code is an implementation of this idea using ethers.js:

```javascript index.js theme={"system"}
const ethers = require("ethers");
const NODE_URL = "CHAINSTACK_NODE_URL";
const provider = new ethers.JsonRpcProvider(NODE_URL);

// A function that returns an array of result and gas fields for each transaction in a block
async function traceBlock(block) {
  try {
    const traces = await provider.send("trace_block", [block]);
    const resultFields = [];
    const gasFields = [];

    for (const { result, action } of traces) {
      resultFields.push(result);
      gasFields.push(action.gas);
    }

    return [resultFields, gasFields];
  } catch (error) {
    console.error(`Error while tracing block: ${error}`);
    throw error;
  }
}

// A function that calculates the total gas used by all transactions in a block
function returnGasUsed(results) {
  const totalGasUsed = results.reduce((total, result) => {
    if (result !== null && result.gasUsed !== undefined) {
      total += Number(BigInt(result.gasUsed));
    }
    return total;
  }, 0);
  return totalGasUsed;
}

// A function that calculates the total gas supplied to a block
function returnTotalGas(gasArray) {
  const totalGas = gasArray.reduce((total, gas) => {
    if (gas !== undefined) {
      total += Number(BigInt(gas));
    }
    return total;
  }, 0);
  return totalGas;
}

// The main function that runs the gas analysis
async function main() {
  try {
    const block = 'latest';
    const [results, gas] = await traceBlock(block);

    const gasUsed = returnGasUsed(results);
    const totalGas = returnTotalGas(gas);
    console.log('===== Gas analysis =====');
    console.log(`Total gas supplied: ${totalGas}`);
    console.log(`Gas used: ${gasUsed}`);
    console.log(`Unused gas: ${totalGas - gasUsed}`);

    const gasUsedPercentage = (gasUsed / totalGas) * 100;
    console.log(`Percentage of gas used: ${gasUsedPercentage.toFixed(2)} %`);
  } catch (error) {
    console.error(`Error while running gas analysis: ${error}`);
  }
}

// Call the main function to start the program
main();
```

The `traceBlock` function takes a block number or tag as an input parameter and returns an array of two elements. The first element is an array of the results of each transaction in the block, which contains the `gasUsed` field, and the second element is an array of the `gas` field used by each call.

The `returnGasUsed` function calculates the total gas used by all transactions in a block by iterating over the results array and summing up the `gasUsed` fields of each non-null element.

The `returnTotalGas` function calculates the total gas supplied to a block by iterating over the `gasArray` array and summing up the non-undefined elements.

The main function calls the `traceBlock` function with the block number or tag calculates the gas used and total gas supplied using the `returnGasUsed` and `returnTotalGas` functions, and outputs the results to the console.

The `main` function is wrapped in a `try-catch` block to handle any errors that may occur during execution.

Finally, the `main` function is called at the end of the script to run the gas analysis.


## OpenAPI

````yaml openapi/polygon_node_api/debug_and_trace/trace_block.json POST /a9bca2f0f84b54086ceebe590316fff3
openapi: 3.0.0
info:
  title: Polygon Node API
  version: 1.0.0
  description: This is an API for interacting with a Polygon node.
servers:
  - url: https://nd-828-700-214.p2pify.com
security: []
paths:
  /a9bca2f0f84b54086ceebe590316fff3:
    post:
      tags:
        - upload
      summary: trace_block
      operationId: trace_block
      requestBody:
        required: true
        content:
          application/json:
            schema:
              type: object
              properties:
                id:
                  type: integer
                  default: 1
                jsonrpc:
                  type: string
                  default: '2.0'
                method:
                  type: string
                  default: trace_block
                params:
                  type: array
                  items:
                    anyOf:
                      - type: string
                        title: Block identifier
                        description: The block number or tag.
                  default:
                    - latest
      responses:
        '200':
          description: The block's trace.
          content:
            application/json:
              schema:
                type: object
                properties:
                  jsonrpc:
                    type: string
                  id:
                    type: integer
                  result:
                    type: object

````